; Script generated by the HM NIS Edit Script Wizard.

; HM NIS Edit Wizard helper defines
!define PRODUCT_NAME "CollisionSkin Editor"
!define PRODUCT_VERSION "1.0"
!define PRODUCT_PUBLISHER "sickbattery"
!define PRODUCT_WEB_SITE "http://jiglibsdx.codeplex.com/"
!define PRODUCT_DIR_REGKEY "Software\Microsoft\Windows\CurrentVersion\App Paths\JigLibSDX CollisionSkin Editor.exe"
!define PRODUCT_UNINST_KEY "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PRODUCT_NAME}"
!define PRODUCT_UNINST_ROOT_KEY "HKLM"
!define PRODUCT_STARTMENU_REGVAL "NSIS:StartMenuDir"

SetCompressor lzma

; MUI 1.67 compatible ------
!include "MUI.nsh"

; MUI Settings
!define MUI_ABORTWARNING
!define MUI_ICON "${NSISDIR}\Contrib\Graphics\Icons\orange-install.ico"
!define MUI_UNICON "${NSISDIR}\Contrib\Graphics\Icons\orange-uninstall.ico"

; MUI Settings / Header
!define MUI_HEADERIMAGE
!define MUI_HEADERIMAGE_RIGHT
!define MUI_HEADERIMAGE_BITMAP "Graphics\jlsdx-cse-header.bmp"
!define MUI_HEADERIMAGE_UNBITMAP "Graphics\jlsdx-cse-header.bmp"

; MUI Settings / Wizard
!define MUI_WELCOMEFINISHPAGE_BITMAP "Graphics\jlsdx-cse.bmp"
!define MUI_UNWELCOMEFINISHPAGE_BITMAP "Graphics\jlsdx-cse.bmp"



; Language Selection Dialog Settings
!define MUI_LANGDLL_REGISTRY_ROOT "${PRODUCT_UNINST_ROOT_KEY}"
!define MUI_LANGDLL_REGISTRY_KEY "${PRODUCT_UNINST_KEY}"
!define MUI_LANGDLL_REGISTRY_VALUENAME "NSIS:Language"

; Welcome page
!insertmacro MUI_PAGE_WELCOME
; License page
!define MUI_LICENSEPAGE_CHECKBOX
!insertmacro MUI_PAGE_LICENSE "CollisionSkin Editor License.txt"
; Directory page
!insertmacro MUI_PAGE_DIRECTORY
; Start menu page
var ICONS_GROUP
!define MUI_STARTMENUPAGE_NODISABLE
!define MUI_STARTMENUPAGE_DEFAULTFOLDER "JigLibSDX CollisionSkin Editor"
!define MUI_STARTMENUPAGE_REGISTRY_ROOT "${PRODUCT_UNINST_ROOT_KEY}"
!define MUI_STARTMENUPAGE_REGISTRY_KEY "${PRODUCT_UNINST_KEY}"
!define MUI_STARTMENUPAGE_REGISTRY_VALUENAME "${PRODUCT_STARTMENU_REGVAL}"
!insertmacro MUI_PAGE_STARTMENU Application $ICONS_GROUP
; Instfiles page
!insertmacro MUI_PAGE_INSTFILES
; Finish page
; !define MUI_FINISHPAGE_RUN "$INSTDIR\JigLibSDX CollisionSkin Editor.exe"
!insertmacro MUI_PAGE_FINISH

; Uninstaller pages
!insertmacro MUI_UNPAGE_INSTFILES

; Language files
!insertmacro MUI_LANGUAGE "English"
;!insertmacro MUI_LANGUAGE "German"

; Reserve files
!insertmacro MUI_RESERVEFILE_INSTALLOPTIONS

; MUI end ------

Name "${PRODUCT_NAME} ${PRODUCT_VERSION}"
OutFile "jlsdx-cse.exe"
InstallDir "$PROGRAMFILES\JigLibSDX CollisionSkin Editor"
InstallDirRegKey HKLM "${PRODUCT_DIR_REGKEY}" ""
ShowInstDetails show
ShowUnInstDetails show

Function .onInit
  !insertmacro MUI_LANGDLL_DISPLAY
FunctionEnd

Section "Hauptgruppe" SEC01
  SetOutPath "$INSTDIR"
  SetOverwrite on
  File "..\bin\Release\JigLibSDX CollisionSkin Editor.exe"
  File "..\bin\Release\JigLibSDX.dll"
  File "..\bin\Release\Physics Engine License.txt"
  SetOutPath "$INSTDIR\Content\Effects"
  SetOverwrite on
  File "..\bin\Release\Content\Effects\Color.fx"
  SetOutPath "$INSTDIR\Content\Meshes"
  File "..\bin\Release\Content\Meshes\box.x"
  File "..\bin\Release\Content\Meshes\capsule_cylinder.x"
  File "..\bin\Release\Content\Meshes\capsule_end.x"
  File "..\bin\Release\Content\Meshes\skysphere.x"
  File "..\bin\Release\Content\Meshes\sphere.x"
  SetOutPath "$INSTDIR\Content\Textures"
  File "..\bin\Release\Content\Textures\sky.png"
  SetOutPath "$INSTDIR"
  SetOverwrite on
  File "..\bin\Release\app.ico"

; Shortcuts
  !insertmacro MUI_STARTMENU_WRITE_BEGIN Application
  CreateDirectory "$SMPROGRAMS\$ICONS_GROUP"
  CreateShortCut "$SMPROGRAMS\$ICONS_GROUP\JigLibSDX CollisionSkin Editor.lnk" "$INSTDIR\JigLibSDX CollisionSkin Editor.exe"
  CreateShortCut "$DESKTOP\JigLibSDX CollisionSkin Editor.lnk" "$INSTDIR\JigLibSDX CollisionSkin Editor.exe"
  !insertmacro MUI_STARTMENU_WRITE_END
SectionEnd

Section -Prerequisites
  SetOutPath "$INSTDIR\Prerequisites"
  MessageBox MB_YESNO "You need the latest SlimDX redistributable to use this editor.$\n$\nDo you want to install it?" /SD IDYES IDNO endActiveSync
    File "C:\Program Files\SlimDX SDK (March 2009)\Bin\slimdx_mar09.msi"
    ExecWait 'msiexec /package "$INSTDIR\Prerequisites\slimdx_mar09.msi" /passive'
    Goto endActiveSync
  endActiveSync:
SectionEnd

Section -AdditionalIcons
  !insertmacro MUI_STARTMENU_WRITE_BEGIN Application
  WriteIniStr "$INSTDIR\${PRODUCT_NAME}.url" "InternetShortcut" "URL" "${PRODUCT_WEB_SITE}"
  CreateShortCut "$SMPROGRAMS\$ICONS_GROUP\Website.lnk" "$INSTDIR\${PRODUCT_NAME}.url"
  CreateShortCut "$SMPROGRAMS\$ICONS_GROUP\Uninstall.lnk" "$INSTDIR\uninst.exe"
  !insertmacro MUI_STARTMENU_WRITE_END
SectionEnd

Section -Post
  WriteUninstaller "$INSTDIR\uninst.exe"
  WriteRegStr HKLM "${PRODUCT_DIR_REGKEY}" "" "$INSTDIR\JigLibSDX CollisionSkin Editor.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayName" "$(^Name)"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "UninstallString" "$INSTDIR\uninst.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayIcon" "$INSTDIR\JigLibSDX CollisionSkin Editor.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayVersion" "${PRODUCT_VERSION}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "URLInfoAbout" "${PRODUCT_WEB_SITE}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "Publisher" "${PRODUCT_PUBLISHER}"
SectionEnd

Function un.onUninstSuccess
  HideWindow
  MessageBox MB_ICONINFORMATION|MB_OK "$(^Name) wurde erfolgreich deinstalliert."
FunctionEnd

Function un.onInit
!insertmacro MUI_UNGETLANGUAGE
  MessageBox MB_ICONQUESTION|MB_YESNO|MB_DEFBUTTON2 "Mchten Sie $(^Name) und alle seinen Komponenten deinstallieren?" IDYES +2
  Abort
FunctionEnd

Section Uninstall
  !insertmacro MUI_STARTMENU_GETFOLDER "Application" $ICONS_GROUP
  Delete "$INSTDIR\${PRODUCT_NAME}.url"
  Delete "$INSTDIR\uninst.exe"
  Delete "$INSTDIR\app.ico"
  Delete "$INSTDIR\Content\Textures\sky.png"
  Delete "$INSTDIR\Content\Meshes\sphere.x"
  Delete "$INSTDIR\Content\Meshes\skysphere.x"
  Delete "$INSTDIR\Content\Meshes\capsule_end.x"
  Delete "$INSTDIR\Content\Meshes\capsule_cylinder.x"
  Delete "$INSTDIR\Content\Meshes\box.x"
  Delete "$INSTDIR\Content\Effects\Color.fx"
  Delete "$INSTDIR\JigLibSDX CollisionSkin Editor.exe"
  Delete "$INSTDIR\JigLibSDX.dll"
  Delete "$INSTDIR\Prerequisites\slimdx_mar09.msi"
  Delete "$INSTDIR\Physics Engine License.txt"

  Delete "$SMPROGRAMS\$ICONS_GROUP\Uninstall.lnk"
  Delete "$SMPROGRAMS\$ICONS_GROUP\Website.lnk"
  Delete "$DESKTOP\JigLibSDX CollisionSkin Editor.lnk"
  Delete "$SMPROGRAMS\$ICONS_GROUP\JigLibSDX CollisionSkin Editor.lnk"

  RMDir "$SMPROGRAMS\$ICONS_GROUP"
  RMDir "$INSTDIR\Content\Textures"
  RMDir "$INSTDIR\Content\Meshes"
  RMDir "$INSTDIR\Content\Effects"
  RMDir "$INSTDIR\Content"
  RMDir "$INSTDIR\Prerequisites"
  RMDir "$INSTDIR"

  DeleteRegKey ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}"
  DeleteRegKey HKLM "${PRODUCT_DIR_REGKEY}"
  SetAutoClose true
SectionEnd